
#ifndef __PROXY_H__
#define __PROXY_H__

pthread_mutex_t sqlmutex; /* Global mutex for SQL connection */

typedef enum loglevel_t {INFO, WARN, ERR} logtype;
struct thread_arg {
	int th_sockfd; /* connection file escriptor  */
	struct sockaddr_in th_addr_in; /* Client network parameters  */
	pthread_t th_thread; /* thread_id  */
	
};

/*
 * cn_info structure is used to store per thread/connection information
 * We should add required time for simulation, etc here.
 */

struct cn_info {
	char     * cn_auth_token;
	uint32_t  cn_relay_port;
	
	int cn_sockfd; /* Client side socket fd  */
	
	struct sockaddr_in cn_addr_in; /* Where I'm relaying now. */

};


/* proxy_client.c */
int prx_client_start(void *);

/* proxy_auth.c */
int prx_auth_callback(char *, int);

/* proxy.c */ 
void shout(logtype,const char*);
#endif
