/*
 *Proxy vlab authentication code.
 */


#include <sys/types.h>
#include <sys/param.h>

#include <sys/socket.h>
#include <sys/wait.h>

#include <netinet/in.h>
#include <arpa/inet.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <err.h>
#include <errno.h>
#include <netdb.h>
#include <string.h>
#include <signal.h>
#include <pthread.h>
#include <mysql.h>


#include "proxy.h"

#define DEFAULT_MYSQL_USER "proxy"
#define DEFAULT_MYSQL_PASS "5r0><Yp4sSw0R|>"
#define DEFAULT_MYSQL_DB "vlab"



/*
 * This is proxy client authentication function, if
 * return value < 0 then authentication failed and
 * we ought to quit.
 */
extern pthread_mutex_t sqlmutex;

int
prx_auth_callback(char *auth_token, int relay_port)
{
	MYSQL *conn=NULL;
	MYSQL_RES *res=NULL;
	MYSQL_ROW row;

	char server[] = "localhost";
	char user[] = DEFAULT_MYSQL_USER;
	char password[] = DEFAULT_MYSQL_PASS; /* set me first */
	char database[] = DEFAULT_MYSQL_DB;
	char *errmsg;

	pthread_mutex_lock( &sqlmutex);
	conn = mysql_init(NULL);

	/* Connect to database */
	if (!mysql_real_connect(conn, server,
				user, password, database, 0, NULL, 0)) {
		goto error;
	}

	/* send SQL query */

	/* OLD Protocol 
	//
	//if (mysql_query(conn, "show tables")) {
	//SELECT user.*, simulation.*, lab.* FROM simulation, lab WHERE SHA1(CONCAT('#',
	//user.username, '@', simulation.id , '@', user.password, '#')) = $RECEIVED_HASH
	//AND
	//simulation.id_lab = lab.id AND $RELAY_PORT >= simulation.first_port AND
	//$RELAY_PORT <=
	//(simulation.first_port + lab.router_count )
	//
	//new protocol
	
	SELECT * FROM simulation s, lab l WHERE
	s.auth_hash = 'hash_co_poslal_client' AND
	s.id_lab = l.id AND
	port_na_ktory_sa_client_sce_pripojit > s.first_port AND
	port_na_ktory_sa_client_sce_pripojit <= (s.first_port + l.router_count + l.host_count + 1)

	*/

/*
	int len = strlen("SELECT * FROM simulation s, lab l WHERE\
		s.auth_hash = 'hash' AND\
		s.id_lab = l.id AND\
		port_n  > s.first_port AND\
		port_n  <= (s.first_port + l.router_count + l.host_count + 1)");
*/
	int len = strlen("SELECT  s.auth_hash,s.id_lab,s.first_port,l.router_count,l.host_count FROM simulation s, lab l WHERE\
		s.auth_hash = 'hash' AND\
		s.id_lab = l.id AND\
		port_n  > s.first_port AND\
		port_n  <= (s.first_port + l.router_count + l.host_count + 1)");


	char * query;
	if((query=(char *)malloc((len+strlen(auth_token)+1)*sizeof(char)))==NULL)
	{
		fprintf(stderr,"not enough mem\n");
		exit(-1);
	}
/*
	snprintf(query,len+strlen(auth_token), "SELECT * FROM simulation s, lab l WHERE\
		s.auth_hash = '%s' AND\
		s.id_lab = l.id AND\
		%d  > s.first_port AND\
		%d  <= (s.first_port + l.router_count + l.host_count + 1)",auth_token,relay_port,relay_port);
		*/
	snprintf(query,len+strlen(auth_token), "SELECT s.auth_hash,s.id_lab,s.first_port,l.router_count,l.host_count FROM simulation s, lab l WHERE \
s.auth_hash = '%s' AND \
s.id_lab = l.id AND \
%d  > s.first_port AND \
%d <= (s.first_port + l.router_count + l.host_count + 1)",auth_token,relay_port,relay_port);
	


	fprintf(stdout,"query: '%s'\n",query);
	if (mysql_query(conn,query))
	{
		goto error;
	}

	res = mysql_use_result(conn);

	/* output
	 * table
	 * name */
	printf("result from mysql query:\n");
	while ((row = mysql_fetch_row(res)) != NULL)
		fprintf(stderr,"row: '%s' \n", row[0]);
	
	/* close
	 * connection
	 * */
	mysql_free_result(res);
	mysql_close(conn);

	
	pthread_mutex_unlock( &sqlmutex);
//	if(dbanswer==)
	
	return 0;

// i don't want to have mysqllock and loglock locked together (could lead to deadlocks)

error: 	
	if ((errmsg=(char* )malloc((1+strlen(mysql_error(conn))*(sizeof(char)))))==NULL) fprintf(stderr,"not enough memory while writing mysql error\n");

	sprintf(errmsg,mysql_error(conn));

	if(res!=NULL) mysql_free_result(res);
	if(conn!=NULL) mysql_close(conn);

	pthread_mutex_unlock( &sqlmutex);

	shout(ERR,errmsg);
	return -1;

}
