#!/bin/sh

#parameters 1=starting_port 2=path to configuration 

TMP_DIR="/tmp/simu/" #directory in which we can create temp files
SIM_DIR=`mktemp -d -p $TMP_DIR` #we create directory to hold nescesary tmp data
VDE_PATH="" #path to vde_switch exutable
UML_PATH="/home/smoco/uml/linux" # path to uml linux exutable
UML_FS_PATH="/home/smoco/uml/root_fs" #
CONF_ID="$2" #configuration of network
PORT_START="$1"

DYNAGEN_PATH="/usr/bin/dynagen"
DYNAMPIS_PATH="/usr/bin/dynamips"
DYNAGENCONF_PATH=`mktemp -p $TMP_DIR`".net"
MYSQL_USER="vlab";
MYSQL_PASS="#VLAB#";
CONF="`/usr/bin/mysql -u $MYSQL_USER --password=$MYSQL_PASS vlab -r -L -N -e \"SELECT lab.configuration FROM lab,simulation WHERE simulation.id=$CONF_ID AND simulation.id_lab=lab.id;\" |grep -v '+-----'`"


#kill all proceses
#function killall_proc {
#	#put here killall to meet specs
#}


if [ -z $VDE_PATH ]; then
	VDE_PATH="vde_switch"
fi
echo "createing tmp dir $SIM_DIR"
CON_PORT=$PORT_START;
cd $SIM_DIR
echo "$CONF" | while read line; do
	#change paths to coresponds with unix sockets and start uml hosts and vde switches
	if [ -n "`echo $line|egrep \"(f|fa)([0-9]/)+[0-9] = host\"`" ];then
		let CON_PORT=$CON_PORT+1;
		HOST_TMPDIR=`mktemp -d -p $SIM_DIR`
		echo "Executing $VDE_PATH -daemon -sock $HOST_TMPDIR/switch"
		$VDE_PATH -daemon -sock $HOST_TMPDIR/switch
		echo "Executing $UML_PATH ubda=$HOST_TMPDIR/cow,$UML_FS_PATH con1=port:$CON_PORT eth0=daemon,,,$HOST_TMPDIR/switch/ctl"
		sleep 1;
		$UML_PATH "ubda=$HOST_TMPDIR/cow,$UML_FS_PATH con1=port:$CON_PORT eth0=daemon,,,$HOST_TMPDIR/switch/ctl" </dev/null >/dev/null &
		line=`echo $line | sed -e "s@host@NIO_vde:$HOST_TMPDIR/switch/ctl:$HOST_TMPDIR/switch/dyna@g" `
	fi
	
	if [ -n "`echo $line|egrep \"console =\"`" ];then
		let CON_PORT=$CON_PORT+1;
		line="console = $CON_PORT"
	fi
	if [ -n "`echo $line|egrep \"port =\"`" ];then
		line="port = $PORT_START"
	fi
	if [ -n "`echo $line|egrep \"workingdir =\"`" ];then
		line="workingdir = $SIM_DIR"
	fi

	echo $line >> $DYNAGENCONF_PATH
done

cd $SIM_DIR

echo "executing $DYNAMPIS_PATH -H $PORT_START"
$DYNAMPIS_PATH -H $PORT_START &
if [ ! "$?" -eq 0 ]; then
	exit -2;
fi;
COUNT=1 
while [ -z "`netstat -l -n|grep $PORT_START`" ];do
	echo "Waiting $COUNT s";
	if [ $COUNT -gt 20 ];then
		echo "Dynamips not started cannot continue"
		killall dynamips
		killall vde_switch
		killall linux
		exit 2;
	fi
	sleep 1;
	let COUNT=$COUNT+1;
done;

echo "$DYNAGEN_PATH $DYNAGENCONF_PATH" 
$DYNAGEN_PATH -b "$DYNAGENCONF_PATH" 
#hmm this part is wasting of time , cannot determine dynagen exit code
if [ ! "$?" -eq 0 ]; then
	exit 4;
fi;
echo "/usr/bin/mysql -u $MYSQL_USER --password=$MYSQL_PASS vlab -e UPDATE simulation SET is_active=1, started=`date +%s` , uid='`whoami`' WHERE id=$CONF_ID; "
/usr/bin/mysql -u $MYSQL_USER --password=$MYSQL_PASS vlab -e "UPDATE simulation SET is_active=1, started=`date +%s` , uid='`whoami`' WHERE id=$CONF_ID ;"

exit 0;
