<?

class lab_dao extends database
{

	function lab_dao($db_link = null) /* {{{ */
	{
		$this->set_db_link($db_link);

	} /* }}} */

	private $query_get_lab_by_id
	= 'SELECT * FROM `lab` WHERE `id` = "?id"';

	function get_lab_by_id($id) /* {{{ */
	{
		$record = $this->get_record($this->query_get_lab_by_id, array(
			'id' => $id
		));

		return $record;

	} /* }}} */

	private $query_set_new_lab
	= 'INSERT `lab` SET `name` = "?name", `picture` = "?picture", `router_count` = "?router_count", `configuration` = "?configuration", `id_autor` = "?id_autor", `id_level` = "?id_level", `document` = "?document"';

	function set_new_lab($name, $picture, $router_count, $configuration, $id_autor, $id_level, $document) /* {{{ */
	{
		$this->query($this->query_set_new_lab, array(
			'name' => $name,
			'picture' => $picture,
			'router_count' => $router_count,
			'configuration' => $configuration,
			'id_autor' => $id_autor,
			'id_level' => $id_level,
			'document' => $document
		));

	} /* }}} */

	private $query_get_labs_by_filter
	= 'SELECT `l`.*, `u`.`first_name`, `u`.`last_name` FROM `lab` l, `user` u WHERE `l`.`name` LIKE "%?name%" AND `l`.`router_count` LIKE "%?router_count%" AND `l`.`configuration` LIKE "%?configuration%" AND `l`.`id_autor` LIKE "?id_autor" AND `l`.`id_level` LIKE "?id_level" AND `l`.`id_autor` = `u`.`id`';

	function get_labs_by_filter($name, $router_count, $configuration, $id_autor, $id_level) /* {{{ */
	{
		$records = $this->get_records($this->query_get_labs_by_filter, array(
			'name' => $name,
			'router_count' => $router_count,
			'configuration' => $configuration,
			'id_autor' => $id_autor,
			'id_level' => $id_level
		));

		return $records;

	} /* }}} */

	private $query_set_lab_by_id
	= 'UPDATE `lab` SET `name` = "?name", `picture` = "?picture", `router_count` = "?router_count", `configuration` = "?configuration", `id_autor` = "?id_autor", `id_level` = "?id_level", `document` = "?document" WHERE `id` = "?id"';

	function set_lab_by_id($id, $name, $picture, $router_count, $configuration, $id_autor, $id_level, $document) /* {{{ */
	{
		$this->query($this->query_set_lab_by_id, array(
			'id' => $id,
			'name' => $name,
			'picture' => $picture,
			'router_count' => $router_count,
			'configuration' => $configuration,
			'id_autor' => $id_autor,
			'id_level' => $id_level,
			'document' => $document
		));

	} /* }}} */

	private $query_del_lab_by_id
	= 'DELETE FROM `lab` WHERE `id` = "?id"';

	function del_lab_by_id($id) /* {{{ */
	{
		$this->query($this->query_del_lab_by_id, array(
			'id' => $id
		));

	} /* }}} */

}

?>
