<?

class reservation_dao extends database
{

	function reservation_dao($db_link = null) /* {{{ */
	{
		$this->set_db_link($db_link);

	} /* }}} */

	private $query_set_new_reservation
	= 'INSERT `reservation` SET `id_user` = "?id_user", `timestamp` = "?timestamp", `unique_str` = "?unique_str"';

	function set_new_reservation($id_user, $timestamp, $unique_str) /* {{{ */
	{
		$this->query($this->query_set_new_reservation, array(
			'id_user' => $id_user,
			'timestamp' => $timestamp,
			'unique_str' => $unique_str
		));

	} /* }}} */

	private $query_get_reservations_by_user
	= 'SELECT `id`, `id_user`, MIN(`timestamp`) timestamp_start, MAX(`timestamp`) timestamp_end FROM `reservation` WHERE `id_user` = "?id_user" GROUP BY `unique_str` ORDER BY `timestamp` DESC';

	function get_reservations_by_user($id_user) /* {{{ */
	{
		$records = $this->get_records($this->query_get_reservations_by_user, array(
			'id_user' => $id_user,
		));

		return $records;

	} /* }}} */

	private $query_get_reservation_by_id
	= 'SELECT * FROM `reservation` WHERE `id` = "?id"';

	function get_reservation_by_id($id) /* {{{ */
	{
		$record = $this->get_record($this->query_get_reservation_by_id, array(
			'id' => $id
		));

		return $record;

	} /* }}} */

	private $query_get_reservation_end_by_unique_str
	= 'SELECT `timestamp` FROM `reservation` WHERE `unique_str` = "?unique_str" ORDER BY `timestamp` DESC';

	function get_reservation_end_by_unique_str($unique_str) /* {{{ */
	{
		$record = $this->get_record($this->query_get_reservation_end_by_unique_str, array(
			'unique_str' => $unique_str
		));

		return $record;

	} /* }}} */

	private $query_get_simulations_by_unique_str
	= 'SELECT `s`.*, `l`.* FROM `simulation` s, `lab` l WHERE `s`.`unique_str` = "?unique_str" AND `l`.`id` = `s`.`id_lab`';

	function get_simulations_by_unique_str($unique_str) /* {{{ */
	{
		$records = $this->get_records($this->query_get_simulations_by_unique_str, array(
			'unique_str' => $unique_str
		));

		return $records;

	} /* }}} */
	
	private $query_get_labs_by_user_level
	= 'SELECT `l`.* FROM `lab` l, `user` u  WHERE `u`.`id` = "?id" AND `u`.`id_level` = `l`.`id_level`';

	function get_labs_by_user_level($id) /* {{{ */
	{
		$records = $this->get_records($this->query_get_labs_by_user_level, array(
			'id' => $id
		));

		return $records;

	} /* }}} */

	private $query_set_new_simulation
	= 'INSERT `simulation` SET `unique_str` = "?unique_str", `id_lab` = "?id_lab", `is_active` = "0", `first_port` = "?first_port", `devices` = "", `started` = "0", `uid` = "", `auth_hash` = "?auth_hash"';

	function set_new_simulation($unique_str, $id_lab, $first_port, $auth_hash) /* {{{ */
	{
		$this->query($this->query_set_new_simulation, array(
			'unique_str' => $unique_str,
			'id_lab' => $id_lab,
			'first_port' => $first_port,
			'auth_hash' => $auth_hash
		));

	} /* }}} */

	private $query_set_simulation_active_by_unique_str
	= 'UPDATE `simulation` SET `is_active` = "0" WHERE `unique_str` = "?unique_str"';

	function set_simulation_active_by_unique_str($unique_str) /* {{{ */
	{
		$this->query($this->query_set_simulation_active_by_unique_str, array(
			'unique_str' => $unique_str
		));

	} /* }}} */
	
	private $query_get_active_simulations_by_timestamp
//	= 'SELECT `s`.* FROM `reservation` r, `simulation` s WHERE `r`.`timestamp` = "?timestamp" AND `r`.`unique_str` = `s`.`unique_str` AND `s`.`is_active` = "1"';
	= 'SELECT `s`.* FROM `reservation` r, `simulation` s WHERE `r`.`unique_str` = `s`.`unique_str` AND `s`.`is_active` = "1"';

	function get_active_simulations_by_timestamp($timestamp) /* {{{ */
	{
		$records = $this->get_records($this->query_get_active_simulations_by_timestamp, array(
			'timestamp' => $timestamp
		));

		return $records;

	} /* }}} */


// -------------------------------------------------


	private $query_get_day_reservations
	= 'SELECT *, SUM(`level.max_router_count`) FROM `reservation`, `user`, `level` WHERE `reservation.timestamp` >= "?start_time" AND `reservation.timestamp` <= "?end_time" AND `user.id` = `reservation.id_user` AND `level.id` = `user.id_level` GROUP BY `reservation.timestamp`';

	function get_day_reservations($start_time, $end_time) /* {{{ */
	{
		$records = $this->get_records($this->query_get_user_by_id, array(
			'start_time' => $start_time,
			'end_time' => $end_time
		));

		return $records;

	} /* }}} */


// -------------------------------------------------


	private $query_set_user_by_id
	= 'UPDATE `user` SET `username` = "?username", `password` = sha1("?password"), `group` = "?group", `first_name` = "?first_name", `last_name` = "?last_name", `email` = "?email" WHERE `id` = "?id"';

	function set_user_by_id($id, $username, $password, $group, $first_name, $last_name, $email) /* {{{ */
	{
		$this->query($this->query_set_user_by_id, array(
			'id' => $id,
			'username' => $username,
			'password' => $password,
			'group' => $group,
			'first_name' => $first_name,
			'last_name' => $last_name,
			'email' => $email
		));

	} /* }}} */

	private $query_del_user_by_id
	= 'DELETE FROM `user` WHERE `id` = "?id"';

	function del_user_by_id($id) /* {{{ */
	{
		$this->query($this->query_del_user_by_id, array(
			'id' => $id
		));

	} /* }}} */

}

?>
