<?

class user_dao extends database
{

	function user_dao($db_link = null) /* {{{ */
	{
		$this->set_db_link($db_link);

	} /* }}} */

	private $query_get_user_by_id
	= 'SELECT * FROM `user` WHERE `id` = "?id"';

	function get_user_by_id($id) /* {{{ */
	{
		$record = $this->get_record($this->query_get_user_by_id, array(
			'id' => $id
		));

		return $record;

	} /* }}} */

	private $query_set_new_user
	= 'INSERT `user` SET `username` = "?username", `password` = sha1("?password"), `group` = "?group", `first_name` = "?first_name", `last_name` = "?last_name", `email` = "?email"';

	function set_new_user($username, $password, $group, $first_name, $last_name, $email) /* {{{ */
	{
		$this->query($this->query_set_new_user, array(
			'username' => $username,
			'password' => $password,
			'group' => $group,
			'first_name' => $first_name,
			'last_name' => $last_name,
			'email' => $email
		));

	} /* }}} */

	private $query_get_users_by_filter
	= 'SELECT * FROM `user` WHERE `username` LIKE "%?username%" AND `group` LIKE "?group" AND `first_name` LIKE "%?first_name%" AND `last_name` LIKE "%?last_name%" AND `email` LIKE "%?email%"';

	function get_users_by_filter($username, $group, $first_name, $last_name, $email) /* {{{ */
	{
		$records = $this->get_records($this->query_get_users_by_filter, array(
			'username' => $username,
			'group' => $group,
			'first_name' => $first_name,
			'last_name' => $last_name,
			'email' => $email
		));

		return $records;

	} /* }}} */

	private $query_set_user_by_id
	= 'UPDATE `user` SET `username` = "?username", `password` = sha1("?password"), `group` = "?group", `first_name` = "?first_name", `last_name` = "?last_name", `email` = "?email" WHERE `id` = "?id"';

	function set_user_by_id($id, $username, $password, $group, $first_name, $last_name, $email) /* {{{ */
	{
		$this->query($this->query_set_user_by_id, array(
			'id' => $id,
			'username' => $username,
			'password' => $password,
			'group' => $group,
			'first_name' => $first_name,
			'last_name' => $last_name,
			'email' => $email
		));

	} /* }}} */

	private $query_del_user_by_id
	= 'DELETE FROM `user` WHERE `id` = "?id"';

	function del_user_by_id($id) /* {{{ */
	{
		$this->query($this->query_del_user_by_id, array(
			'id' => $id
		));

	} /* }}} */

}

?>
