<?

class calendar extends common_module
{
	private $timestamp = 0;
	private $day = 0;
	private $month = 0;
	private $year = 0;

	function calendar() /* {{{ */
	{
		$this->common_module();

		$date = time();

		if (isset($this->get['month']))
		{
			$date = $this->get['month'];

		} elseif (isset($this->get['day']))
		{
			$date = $this->get['day'];

		} elseif (isset($this->get['hour']))
		{
			$date = $this->get['hour'];

		} elseif (isset($this->get['hour_start']))
		{
			$date = $this->get['hour_start'];
		}

		$this->set_by_timestamp($date);

	} /* }}} */

	function set_by_timestamp($timestamp) /* {{{ */
	{
		if (! is_numeric($timestamp))
		{
			$this->error("invalid timestamp input", $timestamp);
			return;
		}

		$this->timestamp = $timestamp;

		$tmp = explode(" ", date("j n Y", $this->timestamp));
		$this->day = $tmp[0];
		$this->month = $tmp[1];
		$this->year = $tmp[2];

		$this->debug("set by timestamp - day : " . $this->day . " - month : " . $this->month . " - year : " . $this->year, $this->timestamp);

	} /* }}} */

	function set_by_date($day, $month, $year) /* {{{ */
	{
		if (! is_numeric($day) OR ! is_numeric($month) OR ! is_numeric($year) OR ! checkdate($month, $day, $year))
		{
			$this->error("invalid date input - day : " . $day . " - month : " . $month . " - year : " . $year);
			return;
		}

		$this->day = $day;
		$this->month = $month;
		$this->year = $year;

		$this->timestamp = mktime(0, 0, 0, $month, $day, $year);

		$this->debug("set by date - day : " . $this->day . " - month : " . $this->month . " - year : " . $this->year, $this->timestamp);

	} /* }}} */

	function generate_month() /* {{{ */
	{
		$this->tpl_array['month_text'] = date("F", $this->timestamp);
		$this->tpl_array['day_text'] = array(1 => "Mon", 2 => "Tue", 3 => "Wen", 4 => "Trh", 5 => "Fri", 6 => "San", 7 => "Son");
		$this->tpl_array['year'] = $this->year;
		$this->tpl_array['today'] = mktime(0, 0, 0, date("n"), date("j"), date("Y"));
		$this->debug("today", $this->tpl_array['today']);

		$this->tpl_array['now'] = time();

		if ($this->month == 1)
		{
			$this->tpl_array['prev_month'] = mktime(0, 0, 0, 12, $this->day, $this->year - 1);
		} else
		{
			$this->tpl_array['prev_month'] = mktime(0, 0, 0, $this->month - 1, $this->day, $this->year);
		}

		if ($this->month == 12)
		{
			$this->tpl_array['next_month'] = mktime(0, 0, 0, 1, $this->day, $this->year + 1);
		} else
		{
			$this->tpl_array['next_month'] = mktime(0, 0, 0, $this->month + 1, $this->day, $this->year);
		}

		$week = 0;
		for ($i = 1; $i <= date("t", $this->timestamp); $i++)
		{
			$date = mktime(0, 0, 0, $this->month, $i, $this->year);
			$this->tpl_array['week'][$week][date("N", $date)]['day_number'] = $i;
			$this->tpl_array['week'][$week][date("N", $date)]['timestamp'] = $date;
			if (date("N", $date) == 7)
			{
				$week++;
			}
		}

		$this->parse("calendar_month.tpl.php");
		return $this->code;

	} /* }}} */

	function generate_day($time_offset = 0, $time_max = 2) /* {{{ */
	{
		// big select for this day
		// group by every hour and check if we can handle another simulation

		// enable hours where we have enough resources and are upper time_offset

		$this->tpl_array['now'] = time();
		if ($time_offset > 0)
		{
			$this->tpl_array['hour_start_timestamp'] = $this->get['hour'];
		}

		for ($i = 0; $i <= 23; $i++)
		{
			$hour_timestamp = mktime($i, 0, 0, $this->month, $this->day, $this->year);

			if (($time_offset > 0) AND ($hour_timestamp > $time_offset) AND ($hour_timestamp < $time_offset + ($time_max * 60 * 60)))
			{
				$this->tpl_array['day'][$i]['available'] = true;

			} elseif ($time_offset == 0)
			{
				$this->tpl_array['day'][$i]['available'] = true;

		//	elseif ( mysql query enough resources )

			} else
			{
				$this->tpl_array['day'][$i]['available'] = false;			
			}

			$this->tpl_array['day'][$i]['timestamp'] = $hour_timestamp;
		}

		$this->parse("calendar_day.tpl.php");
		return $this->code;
		
	} /* }}} */

	function timestamp_strip_hour($timestamp) /* {{{ */
	{
		$tmp = explode(" ", date("j n Y", $timestamp));
		$res = mktime(0, 0, 0, $tmp[1], $tmp[0], $tmp[2]);

		return $res;

	} /* }}} */

	function timestamp_strip_min($timestamp) /* {{{ */
	{
		$tmp = explode(" ", date("j n Y G", $timestamp));
		$res = mktime($tmp[3], 0, 0, $tmp[1], $tmp[0], $tmp[2]);

		return $res;

	} /* }}} */

/* {{{

http://www.weberdev.com/get_example-1385.html

function GetDayDiff($ts_1, $ts_2)
{
        
        #        This will return the difference in days between two PHP timestamps
        #        Robin 06/10/1999
        
        // calculate which is the larger so we never get negative answers
        if ($ts_1 > $ts_2) {
                // $ts_1 is larger
                $var_days = ($ts_1 - $ts_2) / 86400; /// 60 / 60 / 24;
        } elseif ($ts_1 < $ts_2) {
                // $ts_1 is smaller
                $var_days = ($ts_2 - $ts_1) / 86400; /// 60 / 60 / 24;        
        } else {
                // they must be equal
                $var_days = 0;
        }
        return($var_days); //return the value
}

}}} */

}

?>
