<?

include_once("./lib/parser.class.php");

class common_module extends debug
{
	var $get = "";
	var $post = "";
	var $code = "";
	var $tpl_name = "";
	var $tpl_array = array();

	function common_module() /* {{{ */
	{
		$this->debug("common module was created");
		$this->post = $_POST;
		$this->get = $_GET;

	} /* }}} */

	function parse($template = "") /* {{{ */
	{
		if (($template == "") AND ($this->tpl_name == ""))
		{
			$this->code = "";
			return $this->code;
		} else
		{
			$this->tpl_name = $template;
		}

		$parser = new parser($this->debug);
		$this->tpl_array['request']['post'] = $this->post;
		$this->tpl_array['request']['get'] = $this->get;

		$parser->set_compile_dir("./userdata/smarty_tpl/");
		$parser->set_template_dir("./templates/" . get_class($this) . "/");

		if (is_array($this->tpl_name))
		{
			foreach ($this->tpl_name as $tpl)
			{
				$this->code[] = $parser->parse_code($tpl, $this->tpl_array);
			}
		} else
		{
			$this->code = $parser->parse_code($template, $this->tpl_array);
		}

		return $this->code;

	} /* }}} */

	function is_logged() /* {{{ */
	{
		if (isset($_SESSION['logged']) AND $_SESSION['logged'] = true)
		{
			return true;
		} else
		{
			return false;
		}

	} /* }}} */

	function redirect($url) /* {{{ */
	{
		include("./etc/system.etc.php");

		if ($this->debug OR $etc['system']['debug'])
		{
			$this->debug("redirect", $url);
		} else
		{
			header("location:" . $url);
		}
	
	} /* }}} */

}

class module extends common_module
{

	function module() /* {{{ */
	{
		$this->debug("module was created");
		$this->common_module();

	} /* }}} */

	function check_access($module, $action) /* {{{ */
	{
		$access_granted = false;
/*
		if (($module == "") OR ($action == ""))
		{
			$access_granted = false;
			$this->error("invalid module or action", $module . " : " . $action);
		}
*/
		// include registered modules
		include("./etc/modules.etc.php");

		if (isset($_SESSION['group']) AND ($_SESSION['group'] != "") AND
			isset($etc['modules'][$module][$action]['access']) AND
			($_SESSION['group'] <= $etc['modules'][$module][$action]['access']))
		{
			$access_granted = true;
		}

		if ($access_granted)
		{
			$this->debug("access granted", $module . " : " . $action);
		} else
		{
			$this->debug("access not granted", $module . " : " . $action);
		}

		return $access_granted;
	
	} /* }}} */

	function get_action() /* {{{ */
	{
		if (isset($this->get['act']))
		{
			return $this->get['act'];
		}

		// include registered modules
		include("./etc/modules.etc.php");

		foreach($etc['modules'][get_class($this)] as $action => $action_details)
		{
			if (isset($action_details['default']) AND ($action_details['default'] == true))
			{
				return $action;
			}
		}

		return "";

	} /* }}} */

	function run_action() /* {{{ */
	{
		$action = $this->get_action();
		$method = get_class($this) . "_" . $action;

		if (! $this->check_access(get_class($this), $action))
		{
			return;
		}

		if (method_exists($this, $method))
		{
			$this->$method();
		} else
		{
			$this->error("invalid method", $method);
		}

	} /* }}} */

}

?>
