<?

include_once("./dao/lab.dao.php");

class lab extends module
{

	private $lab_dao;
	private $lab_upload_dir = "./userdata/upload/labs";

	function lab($db_link) /* {{{ */
	{
		$this->module();

		$this->lab_dao = new lab_dao($db_link);
		$this->lab_dao->set_debug(true);

		$this->run_action();

	} /* }}} */

	function lab_new() /* {{{ */
	{
		$form = $this->lab_new_form();
		$form_value = $form->form_validate();

		if ($form_value != false)
		{
			$picture_upload = $form->store_uploaded_file($form_value['picture'], $this->lab_upload_dir);
			if ($picture_upload != "")
			{
				$this->lab_dao->set_new_lab($form_value['name'], $picture_upload, $form_value['router_count'], $form_value['configuration'], $_SESSION['id'], /* level */ 0, /*document */ "");
			}

			$this->tpl_array['result_set'] = true;
			if (($this->lab_dao->error_message == "") AND ($picture_upload != ""))
			{
				$form->qform->toggleFrozen(true);
				$this->tpl_array['result_success'] = true;
			} else
			{
				$this->tpl_array['result_success'] = false;
				if (file_exists($picture_upload))
				{
					unlink($picture_upload);
				}
			}
		}

		$this->tpl_array['form'] = $form->get_html();
		$this->parse("lab_new.tpl.php");

	} /* }}} */

	function lab_new_form() /* {{{ */
	{
		$form = new form("lab_new_form", "post");
		$form->qform->setAttribute("action", "index.php?mod=lab&act=new");
		$form->qform->setAttribute('enctype', 'multipart/form-data');

		// override whatever value was submitted
		$form->qform->addElement('hidden', 'MAX_FILE_SIZE')->setValue('102400');
/*
		$form->addDataSource(new HTML_QuickForm2_DataSource_Array(array(
			'username' => "default username value"
		)));
//		$item->toggleFrozen(false);
*/
		$form_content = $form->qform->addElement("fieldset")->setLabel("New Lab");

		$name = $form_content->addElement("text", "name");
		$name->setLabel("Name :");
		$name->addRule("required", "name is required");

		$picture = $form_content->addElement('file', 'picture');
		$picture->setLabel('Picture (gif, jpg, png) :');
		$picture->addRule('required', 'Please upload picture');
		$picture->addRule('regex', 'Allowed extensions: .gif, .jp(e)g, .png', '/\\.(gif|jpe?g|png)$/i');
		$picture->addRule('mimetype', 'Your browser doesn\'t think that\'s an image', array('image/gif', 'image/png', 'image/jpeg', 'image/pjpeg'));
		$picture->addRule('maxfilesize', 'File is too big, allowed size 20kB', 20480);

		$router_count = $form_content->addElement("text", "router_count");
		$router_count->setLabel("Router count :");
		$router_count->addRule("required", "router count is required");

		$configuration = $form_content->addElement("textarea", "configuration", array('cols' => 65, 'rows' => 30));
		$configuration->setLabel("Configuration :");
		$configuration->addRule("required", "configuration is required");

//		set level

		$form_content->addElement("reset", "Reset", array('value' => "Reset Data"));
		$form_content->addElement("submit", "Submit", array('value' => "Add New Lab"));

		return $form;

	} /* }}} */

	function lab_list() /* {{{ */
	{
		$form = $this->lab_list_form();
		$form_value = $form->form_validate();

		$records = $this->lab_dao->get_labs_by_filter($form_value['name'], $form_value['router_count'], $form_value['configuration'], /* $form_value['id_autor'] */ "%", /* $form_value['id_level'] */ "%");
		foreach ($records as $key => $record)
		{
			$records[$key]['configuration'] = nl2br($record['configuration']);
		}
		$this->tpl_array['lab_list'] = $records;

		if ($this->check_access("lab", "edit"))
		{
			$this->tpl_array['lab_edit'] = true;
		}

		if ($this->check_access("lab", "del"))
		{
			$this->tpl_array['lab_del'] = true;
		}

		$this->tpl_array['form'] = $form->get_html();
		$this->parse("lab_list.tpl.php");

	} /* }}} */

	function lab_list_form() /* {{{ */
	{
		$form = new form("lab_list_form", "post");
		$form->qform->setAttribute("action", "index.php?mod=lab&act=list");

		$form_content = $form->qform->addElement("fieldset")->setLabel("Filter Labs");

		$name = $form_content->addElement("text", "name");
		$name->setLabel("Name :");

		$router_count = $form_content->addElement("text", "router_count");
		$router_count->setLabel("Router count :");

		$configuration = $form_content->addElement("text", "configuration");
		$configuration->setLabel("Configuration :");

		$id_autor_options = array(
			"Doesn't matter"
		);

		$id_autor = $form_content->addElement("select", "id_autor", null, array('options' => $id_autor_options));
		$id_autor->setLabel("Autor :");

		$id_level_options = array(
			"Doesn't matter"
		);

		$id_level = $form_content->addElement("select", "id_level", null, array('options' => $id_level_options));
		$id_level->setLabel("Level :");

		$form_content->addElement("reset", "Reset", array('value' => "Reset Data"));
		$form_content->addElement("submit", "Submit", array('value' => "Filter Labs"));

		return $form;

	} /* }}} */

	function lab_edit() /* {{{ */
	{
		if (! isset($this->get['id']) OR ! is_numeric($this->get['id']))
		{
			$this->error("invalid id");
			return;
		}

		$lab_value = $this->lab_dao->get_lab_by_id($this->get['id']);
		$this->debug("lab values", $lab_value);

		$form = $this->lab_edit_form($lab_value);
		$form_value = $form->form_validate();

		if ($form_value != false)
		{
			if ($form_value['picture']['name'] != "")
			{
				$picture_upload = $form->store_uploaded_file($form_value['picture'], $this->lab_upload_dir);
			} else
			{
				$picture_upload = $lab_value['picture'];
			}
			if ($picture_upload != "")
			{
				$this->lab_dao->set_lab_by_id($this->get['id'], $form_value['name'], $picture_upload, $form_value['router_count'], $form_value['configuration'], $_SESSION['id'], /* level */ 0, /*document */ "");
			}

			$this->tpl_array['result_set'] = true;
			if (($this->lab_dao->error_message == "") AND ($picture_upload != ""))
			{
				$form->qform->toggleFrozen(true);
				$this->tpl_array['result_success'] = true;
				if (file_exists($lab_value['picture']) AND ($picture_upload != $lab_value['picture']))
				{
					$this->debug("unliking file", $lab_value['picture']);
					unlink($lab_value['picture']);
				}
			} else
			{
				$this->tpl_array['result_success'] = false;
				if (file_exists($picture_upload) AND ($picture_upload != $lab_value['picture']))
				{
					$this->debug("unliking file", $picture_upload);
					unlink($picture_upload);
				}
			}
		}

		$this->tpl_array['form'] = $form->get_html();
		$this->parse("lab_edit.tpl.php");

	} /* }}} */

	function lab_edit_form($default_values) /* {{{ */
	{
		$form = new form("lab_edit_form", "post");
		$form->qform->setAttribute("action", "index.php?mod=lab&act=edit&id=" . $this->get['id']);
		$form->qform->setAttribute('enctype', 'multipart/form-data');

		// override whatever value was submitted
		$form->qform->addElement('hidden', 'MAX_FILE_SIZE')->setValue('102400');

		$form->qform->addDataSource(new HTML_QuickForm2_DataSource_Array(array(
			'name' => $default_values['name'],
			'router_count' => $default_values['router_count'],
			'configuration' => $default_values['configuration'],
			'id_autor' => $default_values['id_autor'],
			'id_level' => $default_values['id_level'],
		)));

		$form_content = $form->qform->addElement("fieldset")->setLabel("New Lab");

		$name = $form_content->addElement("text", "name");
		$name->setLabel("Name :");
		$name->addRule("required", "name is required");

		$picture = $form_content->addElement('file', 'picture');
		$picture->setLabel('Picture (gif, jpg, png) :');
//		$picture->addRule('required', 'Please upload picture');
		$picture->addRule('regex', 'Allowed extensions: .gif, .jp(e)g, .png', '/\\.(gif|jpe?g|png)$/i');
		$picture->addRule('mimetype', 'Your browser doesn\'t think that\'s an image', array('image/gif', 'image/png', 'image/jpeg', 'image/pjpeg'));
		$picture->addRule('maxfilesize', 'File is too big, allowed size 20kB', 20480);

		$current_picture = $form_content->addElement('image', 'current_picture', array('src' => $default_values['picture']));

		$router_count = $form_content->addElement("text", "router_count");
		$router_count->setLabel("Router count :");
		$router_count->addRule("required", "router count is required");

		$configuration = $form_content->addElement("textarea", "configuration", array('cols' => 65, 'rows' => 30));
		$configuration->setLabel("Configuration :");
		$configuration->addRule("required", "configuration is required");

//		set level

		$form_content->addElement("reset", "Reset", array('value' => "Reset Data"));
		$form_content->addElement("submit", "Submit", array('value' => "Update Lab"));

		return $form;

	} /* }}} */

	function lab_del() /* {{{ */
	{
		if (! isset($this->get['id']) OR ! is_numeric($this->get['id']))
		{
			$this->error("invalid id");
			return;
		}

		$lab_value = $this->lab_dao->get_lab_by_id($this->get['id']);
		$this->debug("lab values", $lab_value);

		$form = $this->lab_del_form($lab_value);
		$form->qform->toggleFrozen(true);
		$form_value = $form->form_validate();

		if ($form_value != false)
		{
			$this->lab_dao->del_lab_by_id($this->get['id']);

			$this->tpl_array['result_set'] = true;
			if ($this->lab_dao->error_message == "")
			{
				$this->tpl_array['result_success'] = true;
				if (file_exists($lab_value['picture']))
				{
					$this->debug("unliking file", $lab_value['picture']);
					unlink($lab_value['picture']);
				}
			} else
			{
				$this->tpl_array['result_success'] = false;
			}
		}

		$this->tpl_array['form'] = $form->get_html();
		$this->parse("lab_del.tpl.php");

	} /* }}} */

	function lab_del_form($default_values) /* {{{ */
	{
		$form = new form("lab_del_form", "post");
		$form->qform->setAttribute("action", "index.php?mod=lab&act=del&id=" . $this->get['id']);

		$form->qform->addDataSource(new HTML_QuickForm2_DataSource_Array(array(
			'name' => $default_values['name'],
			'router_count' => $default_values['router_count'],
			'configuration' => $default_values['configuration'],
			'id_autor' => $default_values['id_autor'],
			'id_level' => $default_values['id_level'],
		)));

		$form_content = $form->qform->addElement("fieldset")->setLabel("Delete Lab");

		$name = $form_content->addElement("text", "name");
		$name->setLabel("Name :");

		$picture = $form_content->addElement('image', 'picture', array('src' => $default_values['picture']));

		$router_count = $form_content->addElement("text", "router_count");
		$router_count->setLabel("Router count :");

		$configuration = $form_content->addElement("textarea", "configuration", array('cols' => 65, 'rows' => 30));
		$configuration->setLabel("Configuration :");

//		set level

		$form_content->addElement("submit", "Submit", array('value' => "Delete Lab"));

		return $form;

	} /* }}} */

	function user_own() /* {{{ */
	{
		$user_profile = $this->user_dao->get_user_by_id($_SESSION['id']);
		$this->debug("user profile", $user_profile);

		$form = $this->user_own_form($user_profile);
		$form_value = $form->form_validate();

		if ($form_value != false)
		{
			$this->user_dao->set_user_by_id($_SESSION['id'], $form_value['username'], $form_value['password'], $form_value['group'], $form_value['first_name'], $form_value['last_name'], $form_value['email']);

			$this->tpl_array['result_set'] = true;
			if ($this->user_dao->error_message == "")
			{
				$form->qform->toggleFrozen(true);
				$this->tpl_array['result_success'] = true;
			} else
			{
				$this->tpl_array['result_success'] = false;
			}
		}

		$this->tpl_array['form'] = $form->get_html();
		$this->parse("user_own.tpl.php");

	} /* }}} */

	function user_own_form($default_values) /* {{{ */
	{
		$form = new form("user_own_form", "post");
		$form->qform->setAttribute("action", "index.php?mod=user&act=own");

		$form->qform->addDataSource(new HTML_QuickForm2_DataSource_Array(array(
			'username' => $default_values['username'],
			'group' => $default_values['group'],
			'first_name' => $default_values['first_name'],
			'last_name' => $default_values['last_name'],
			'email' => $default_values['email']
		)));

		$form_content = $form->qform->addElement("fieldset")->setLabel("Your Profile");

		$username = $form_content->addElement("text", "username" /* , array('style' => $default_input_style) */ );
		$username->setLabel("Username :");
		$username->addRule("required", "username is required");
		$username->toggleFrozen(true);

		$password = $form_content->addElement("text", "password");
		$password->setLabel("Password :");
		$password->addRule("required", "password is required");

		$group_options = array(
			"Administrator",
			"Teacher",
			"Student"
		);

		$group = $form_content->addElement("select", "group", null, array('options' => $group_options));
		$group->setLabel("Group :");
		$group->addRule("required", "group is required");
		$group->toggleFrozen(true);

		$first_name = $form_content->addElement("text", "first_name");
		$first_name->setLabel("First Name :");
		$first_name->addRule("required", "first name is required");

		$last_name = $form_content->addElement("text", "last_name");
		$last_name->setLabel("Last Name :");
		$last_name->addRule("required", "last name is required");
	
		$email = $form_content->addElement("text", "email");
		$email->setLabel("Email :");
		$email->addRule("required", "email is required");

		$form_content->addElement("reset", "testReset", array('value' => "Reset Data"));
		$form_content->addElement("submit", "testSubmit", array('value' => "Update Profile"));

		return $form;

	} /* }}} */

}

?>

