<?

include_once("./dao/reservation.dao.php");
include("./lib/calendar.class.php");

class reservation extends module
{

	private $reservation_dao;

	function reservation($db_link) /* {{{ */
	{
		$this->module();

		$this->reservation_dao = new reservation_dao($db_link);
		$this->reservation_dao->set_debug(true);

		$this->run_action();

	} /* }}} */

	function get_unique_str($value) /* {{{ */
	{
		return sha1("vlab" . rand(0, 65535) . "unique_string" . rand(0, 65535) . "for_user" . $_SESSION['id'] . "value" . $value . "vlab");

	} /* }}} */

	function reservation_new() /* {{{ */
	{
		$calendar = new calendar();

		$this->tpl_array['month'] = $calendar->generate_month();

		if (isset($this->get['day']))
		{
			$this->tpl_array['hour_start'] = $calendar->generate_day();

		} elseif (isset($this->get['hour']))
		{
			$this->tpl_array['hour_start_value'] = date("D  d.m.Y  H:i:s", $calendar->timestamp_strip_min($this->get['hour']));
			$this->tpl_array['hour_end'] = $calendar->generate_day($calendar->timestamp_strip_min($this->get['hour']), /* get max hour from level */ 5);

		} elseif (isset($this->get['hour_start']) AND isset($this->get['hour_end']))
		{
			$this->tpl_array['hour_start_value'] = date("D  d.m.Y  H:i:s", $calendar->timestamp_strip_min($this->get['hour_start']));
			$this->tpl_array['hour_end_value'] = date("D  d.m.Y  H:i:s", $calendar->timestamp_strip_min($this->get['hour_end']));
		}

		$form = $this->reservation_new_form();
		$form_value = $form->form_validate();

		if ($form_value != false)
		{
			if (($form_value['hour_start'] < $form_value['hour_end']) AND
				($form_value['hour_start'] > time()) AND
				($form_value['hour_end'] > time()) AND
				($form_value['hour_start'] % (60 * 60) == 0) AND
				($form_value['hour_end'] % (60 * 60) == 0)

//				max hour count check ( spec. in level )
//				check enough resources
				
				)
			{
				$req_hours = ($form_value['hour_end'] - $form_value['hour_start']) / (60 * 60);
				$this->debug("start hour - timestamp : " . $form_value['hour_start'] . " value :" . date("D  d.m.Y  H:i:s", $form_value['hour_start']));
				$this->debug("end hour - timestamp : " . $form_value['hour_end'] . " value : " . date("D  d.m.Y  H:i:s", $form_value['hour_end']));
				$this->debug("requested hours", $req_hours);

				$res_success = true;
				$res_id = array();
				$unique_str = $this->get_unique_str($form_value['hour_start'] . "/" . $form_value['hour_end']);
				for ($i = 0; $i < $req_hours; $i++)
				{
					$tmp_timestamp = $form_value['hour_start'] + ($i * (60 * 60));
					$this->debug("reservation for timestamp", $tmp_timestamp);

					$this->reservation_dao->set_new_reservation($_SESSION['id'], $tmp_timestamp, $unique_str);
					if ($this->reservation_dao->error_message != "")
					{
						$res_success = false;
					}
					$res_id[] = $this->reservation_dao->insert_id();
				}
				$this->debug("record id", $res_id);

				$this->tpl_array['result_set'] = true;
				if ($res_success)
				{
					$form->qform->toggleFrozen(true);
					$this->tpl_array['result_success'] = true;
				} else
				{
					$this->tpl_array['result_success'] = false;

					// probably one insert was not successful
					// delete all inserted records
				}
			} else
			{
				$this->error("invalid start/end hour value");
			}
		}

		$this->tpl_array['form'] = $form->get_html();
		$this->parse("reservation_new.tpl.php");

	} /* }}} */

	function reservation_new_form() /* {{{ */
	{
		$form = new form("reservation_new_form", "post");
		$form->qform->setAttribute("action", "index.php?mod=reservation&act=new");

		$form->qform->addDataSource(new HTML_QuickForm2_DataSource_Array(array(
			'hour_start' => $this->get['hour_start'],
			'hour_start_value' => date("D  d.m.Y  H:i:s", calendar::timestamp_strip_min($this->get['hour_start'])),
			'hour_end' => $this->get['hour_end'],
			'hour_end_value' => date("D  d.m.Y  H:i:s", calendar::timestamp_strip_min($this->get['hour_end']))
		)));

		$form_content = $form->qform->addElement("fieldset")->setLabel("New Reservation");

		$hour_start_value = $form_content->addElement("text", "hour_start_value");
		$hour_start_value->setLabel("Start hour :");
		$hour_start_value->toggleFrozen(true);

		$hour_end_value = $form_content->addElement("text", "hour_end_value");
		$hour_end_value->setLabel("End hour :");
		$hour_end_value->toggleFrozen(true);

		$hour_start_timestamp = $form_content->addElement("hidden", "hour_start");
		$hour_start_timestamp->addRule("required", "start hour is required");

		$hour_end_timestamp = $form_content->addElement("hidden", "hour_end");
		$hour_end_timestamp->addRule("required", "end hour is required");

		$form_content->addElement("submit", "Submit", array('value' => "Create reservation"));

		return $form;

	} /* }}} */

	function reservation_own() /* {{{ */
	{
		$records = $this->reservation_dao->get_reservations_by_user($_SESSION['id']);

		foreach ($records as $key => $reservation)
		{
			$records[$key]['timestamp_start_value'] = date("D  d.m.Y  H:i:s", $records[$key]['timestamp_start']);
			$records[$key]['timestamp_end_value'] = date("D  d.m.Y  H:i:s", $records[$key]['timestamp_end']);
		}
		$this->tpl_array['reservation_list'] = $records;

		$this->tpl_array['now'] = time();
		$this->parse("reservation_own.tpl.php");

	} /* }}} */

	function get_active_simulation($simulations) /* {{{ */
	{
		foreach ($simulations as $key => $simulation)
		{
			if ($simulation['is_active'])
			{
				return $simulation;
			}
		}
		return array();

	} /* }}} */

	function get_auth_hash($value) /* {{{ */
	{
		return sha1("vlab" . rand(0, 65535) . "auth_hash" . rand(0, 65535) . "for_user" . $_SESSION['id'] . "value" . $value . "vlab");

	} /* }}} */

	function get_first_port() /* {{{ */
	{
		$timestamp = calendar::timestamp_strip_min(time());
		$active_simulations = $this->reservation_dao->get_active_simulations_by_timestamp($timestamp);
	
		$this->debug("active simulation", $active_simulations);

		for ($port = 9000; $port < 65500; $port += 20)
		{
			$port_used = false;
			foreach ($active_simulations as $key => $simulation)
			{
				if ($simulation['first_port'] == $port)
				{
					$port_used = true;
				}
			}

			if (! $port_used)
			{
				$this->debug("first port will be", $port);
				return $port;
			}
		}

		$this->error("unable to get first port");
		return -1;

	} /* }}} */

	function get_reservation_end($unique_str) /* {{{ */
	{
		$result = /* time() - */ $this->reservation_dao->get_reservation_end_by_unique_str($unique_str);

		return $result['timestamp'];

	} /* }}} */

	function reservation_simulation() /* {{{ */
	{
		if (! isset($this->get['id']) OR ! is_numeric($this->get['id']))
		{
			$this->error("invalid id");
			return;
		}
		$reservation = $this->reservation_dao->get_reservation_by_id($this->get['id']);
//		$this->debug("reservation", $reservation);

		$simulations = $this->reservation_dao->get_simulations_by_unique_str($reservation['unique_str']);
//		$this->debug("simulations", $simulations);

		$active_simulation = $this->get_active_simulation($simulations);
//		$this->debug("active simulation", $active_simulation);
		if ($active_simulation == array())
		{					// no active simulation
			$this->debug("no active simulation");

			$labs = $this->reservation_dao->get_labs_by_user_level($_SESSION['id']);

			if (! empty($labs))
			{
				$form = $this->reservation_simulation_select_form($labs);
				$form_value = $form->form_validate();

				$this->tpl_array['form'] = $form->get_html();
			}

			$this->tpl_array['labs_count'] = count($labs);
			$this->parse("reservation_simulation.tpl.php");

			if (isset($form_value['start_lab']))
			{
				// find first port parameter and put in db (some random modulo alg. check in all active simulations)

				$first_port = $this->get_first_port();
				if ($first_port == -1)
				{
					return;
				}
				$auth_hash = $this->get_auth_hash($reservation['unique_str']);

				$this->reservation_dao->set_new_simulation($reservation['unique_str'], $form_value['lab'], $first_port, $auth_hash);

				$sim_id = $this->reservation_dao->insert_id();
				$kill_delay = $this->get_reservation_end($reservation['unique_str']);

				$command = "/opt/scripts/startup.sh $first_port $sim_id $kill_delay < /dev/null > /tmp/debug_start";

				$this->debug("starting simulation", $command);

				$output = array();
				$return_var = 0;
				exec($command, $output, $return_var);

				$this->debug("command output", $output);
				$this->debug("command return var", $return_var);
			}

		} else
		{					// active simulation

			// get device list - array ( device => port , ... ) --- use first port from active simulation as parameter

			// new -- from db devices xml to parse

			$device = array(
				'9001' => 'web'
//				$active_simulation['first_port'] + 1 => 'default_host',
//				$active_simulation['first_port'] + 2 => 'default_router'
			);

			$form = $this->reservation_simulation_connect_form($active_simulation, $device);
			$form_value = $form->form_validate();

			if (isset($form_value['connect']) AND isset($form_value['device']) AND
				($form_value['device'] > $active_simulation['first_port']) AND
				($form_value['device'] <= $active_simulation['first_port'] + $active_simulation['router_count'] + $active_simulation['host_count'] + 1)
			)
			{
				$this->debug("connecting to device ...");
				$this->tpl_array['device'] = $device[$form_value['device']];
				$this->tpl_array['relay_port'] = $form_value['device'];
				$this->tpl_array['auth_hash'] = $active_simulation['auth_hash'];

			} elseif (isset($form_value['stop_lab']))
			{
				$uid = $active_simulation['uid'];
				$kill_delay = 0;

				$command = "/usr/bin/sudo /opt/scripts/shutdown.sh $kill_delay $uid < /dev/null > /tmp/debug_kill";

				$this->debug("killing simulation", $command);

				$this->reservation_dao->set_simulation_active_by_unique_str($reservation['unique_str']);

				$output = array();
				$return_var = 0;
				exec($command, $output, $return_var);

				$this->debug("command output", $output);
				$this->debug("command return var", $return_var);
			}

			$this->tpl_array['form'] = $form->get_html();
			$this->parse("reservation_connection.tpl.php");

		}

	} /* }}} */

	function reservation_simulation_select_form($labs) /* {{{ */
	{
		$form = new form("simulation_select_form", "post");
		$form->qform->setAttribute("action", "index.php?mod=reservation&act=simulation&id=" . $this->get['id']);
	
		$form_content = $form->qform->addElement("fieldset")->setLabel("Select simulation");

		$tmp_picture_path = "";

		if (! isset($this->post['lab']))
		{
			reset($labs);
//			$this->post['lab'] = key($labs);
			$this->post['lab'] = $labs[0]['id'];
		}

		foreach ($labs as $key => $lab)
		{
			$lab_options[$lab['id']] = $lab['name'];
			if ($lab['id'] == $this->post['lab'])
			{
				$tmp_picture_path = $lab['picture'];
			}
		}

		$lab = $form_content->addElement("select", "lab", null, array('options' => $lab_options));
		$lab->setLabel("Lab :");

		$lab_picture = $form_content->addElement('image', 'lab_picture', array('src' => $tmp_picture_path /* $labs[$this->post['lab']]['picture'] */ ));

		$form_content->addElement("submit", "select_lab", array('value' => "Select Lab"));
		$form_content->addElement("submit", "start_lab", array('value' => "Start Lab"));

		return $form;

	} /* }}} */

	function reservation_simulation_connect_form($lab, $device) /* {{{ */
	{
		$form = new form("simulation_select_form", "post");
		$form->qform->setAttribute("action", "index.php?mod=reservation&act=simulation&id=" . $this->get['id']);

		$form_content = $form->qform->addElement("fieldset")->setLabel("Connect to simulation");

		$lab_picture = $form_content->addElement('image', 'lab_picture', array('src' => $lab['picture']));

		$device = $form_content->addElement("select", "device", null, array('options' => $device));
		$device->setLabel("Device :");
		$device->addRule("required", "device is required");

		$form_content->addElement("submit", "connect", array('value' => "Connect"));
		$form_content->addElement("submit", "stop_lab", array('value' => "Stop active simulation"));

		return $form;

	} /* }}} */

}

?>

