<?

include_once("./dao/user.dao.php");

class user extends module
{

	private $user_dao;

	function user($db_link) /* {{{ */
	{
		$this->module();

		$this->user_dao = new user_dao($db_link);
		$this->user_dao->set_debug(true);

		$this->run_action();

	} /* }}} */

	function user_new() /* {{{ */
	{
		$form = $this->user_new_form();
		$form_value = $form->form_validate();

		if ($form_value != false)
		{
			$this->user_dao->set_new_user($form_value['username'], $form_value['password'], $form_value['group'], $form_value['first_name'], $form_value['last_name'], $form_value['email']);

			$this->tpl_array['result_set'] = true;
			if ($this->user_dao->error_message == "")
			{
				$form->qform->toggleFrozen(true);
				$this->tpl_array['result_success'] = true;
			} else
			{
				$this->tpl_array['result_success'] = false;
			}
		}

		$this->tpl_array['form'] = $form->get_html();
		$this->parse("user_new.tpl.php");

	} /* }}} */

	function user_new_form() /* {{{ */
	{
		$form = new form("user_new_form", "post");
		$form->qform->setAttribute("action", "index.php?mod=user&act=new");
/*
		$form->addDataSource(new HTML_QuickForm2_DataSource_Array(array(
			'username' => "default username value"
		)));
*/
//		$default_input_style = "width: 150px; border: 1px solid darkgray";

		$form_content = $form->qform->addElement("fieldset")->setLabel("New User");

		$username = $form_content->addElement("text", "username" /* , array('style' => $default_input_style) */ );
		$username->setLabel("Username :");
		$username->addRule("required", "username is required");
//		$username->toggleFrozen(false);

		$password = $form_content->addElement("text", "password" /* , array('style' => $default_input_style) */ );
		$password->setLabel("Password :");
		$password->addRule("required", "password is required");

		$group_options = array(
			"Administrator",
			"Teacher",
			"Student"
		);

		$group = $form_content->addElement("select", "group", null, array('options' => $group_options));
		$group->setLabel("Group :");
		$group->addRule("required", "group is required");

		$first_name = $form_content->addElement("text", "first_name" /* , array('style' => $default_input_style) */ );
		$first_name->setLabel("First Name :");
		$first_name->addRule("required", "first name is required");

		$last_name = $form_content->addElement("text", "last_name" /* , array('style' => $default_input_style) */ );
		$last_name->setLabel("Last Name :");
		$last_name->addRule("required", "last name is required");
	
		$email = $form_content->addElement("text", "email" /* , array('style' => $default_input_style) */ );
		$email->setLabel("Email :");
		$email->addRule("required", "email is required");

		$form_content->addElement("reset", "testReset", array('value' => "Reset Data"));
		$form_content->addElement("submit", "testSubmit", array('value' => "Add New User"));

		return $form;

	} /* }}} */

	function user_list() /* {{{ */
	{
		$form = $this->user_list_form();
		$form_value = $form->form_validate();
		$this->debug("form value", $form_value);

		if (($form_value['group'] == 0) OR (($form_value['group'] == "")))
		{
			$form_value['group'] = "%";
		} else
		{
			$form_value['group']--; 
		}
		$records = $this->user_dao->get_users_by_filter($form_value['username'], $form_value['group'], $form_value['first_name'], $form_value['last_name'], $form_value['email']);
		$this->tpl_array['user_list'] = $records;

		if ($this->check_access("user", "edit"))
		{
			$this->tpl_array['user_edit'] = true;
		}

		if ($this->check_access("user", "del"))
		{
			$this->tpl_array['user_del'] = true;
		}

		$this->tpl_array['form'] = $form->get_html();
		$this->parse("user_list.tpl.php");

	} /* }}} */

	function user_list_form() /* {{{ */
	{
		$form = new form("user_list_form", "post");
		$form->qform->setAttribute("action", "index.php?mod=user&act=list");

		$form_content = $form->qform->addElement("fieldset")->setLabel("Filter Users");

		$username = $form_content->addElement("text", "username");
		$username->setLabel("Username :");

		$group_options = array(
			"Doesn't matter",
			"Administrator",
			"Teacher",
			"Student"
		);

		$group = $form_content->addElement("select", "group", null, array('options' => $group_options));
		$group->setLabel("Group :");

		$first_name = $form_content->addElement("text", "first_name");
		$first_name->setLabel("First Name :");

		$last_name = $form_content->addElement("text", "last_name");
		$last_name->setLabel("Last Name :");
	
		$email = $form_content->addElement("text", "email");
		$email->setLabel("Email :");

		$form_content->addElement("reset", "testReset", array('value' => "Reset Data"));
		$form_content->addElement("submit", "testSubmit", array('value' => "Filter Users"));

		return $form;

	} /* }}} */

	function user_own() /* {{{ */
	{
		$user_profile = $this->user_dao->get_user_by_id($_SESSION['id']);
		$this->debug("user profile", $user_profile);

		$form = $this->user_own_form($user_profile);
		$form_value = $form->form_validate();

		if ($form_value != false)
		{
			$this->user_dao->set_user_by_id($_SESSION['id'], $form_value['username'], $form_value['password'], $form_value['group'], $form_value['first_name'], $form_value['last_name'], $form_value['email']);

			$this->tpl_array['result_set'] = true;
			if ($this->user_dao->error_message == "")
			{
				$form->qform->toggleFrozen(true);
				$this->tpl_array['result_success'] = true;
			} else
			{
				$this->tpl_array['result_success'] = false;
			}
		}

		$this->tpl_array['form'] = $form->get_html();
		$this->parse("user_own.tpl.php");

	} /* }}} */

	function user_own_form($default_values) /* {{{ */
	{
		$form = new form("user_own_form", "post");
		$form->qform->setAttribute("action", "index.php?mod=user&act=own");

		$form->qform->addDataSource(new HTML_QuickForm2_DataSource_Array(array(
			'username' => $default_values['username'],
			'group' => $default_values['group'],
			'first_name' => $default_values['first_name'],
			'last_name' => $default_values['last_name'],
			'email' => $default_values['email']
		)));

		$form_content = $form->qform->addElement("fieldset")->setLabel("Your Profile");

		$username = $form_content->addElement("text", "username" /* , array('style' => $default_input_style) */ );
		$username->setLabel("Username :");
		$username->addRule("required", "username is required");
		$username->toggleFrozen(true);

		$password = $form_content->addElement("text", "password");
		$password->setLabel("Password :");
		$password->addRule("required", "password is required");

		$group_options = array(
			"Administrator",
			"Teacher",
			"Student"
		);

		$group = $form_content->addElement("select", "group", null, array('options' => $group_options));
		$group->setLabel("Group :");
		$group->addRule("required", "group is required");
		$group->toggleFrozen(true);

		$first_name = $form_content->addElement("text", "first_name");
		$first_name->setLabel("First Name :");
		$first_name->addRule("required", "first name is required");

		$last_name = $form_content->addElement("text", "last_name");
		$last_name->setLabel("Last Name :");
		$last_name->addRule("required", "last name is required");
	
		$email = $form_content->addElement("text", "email");
		$email->setLabel("Email :");
		$email->addRule("required", "email is required");

		$form_content->addElement("reset", "testReset", array('value' => "Reset Data"));
		$form_content->addElement("submit", "testSubmit", array('value' => "Update Profile"));

		return $form;

	} /* }}} */

	function user_edit() /* {{{ */
	{
		if (! isset($this->get['id']) OR ! is_numeric($this->get['id']))
		{
			$this->error("invalid id");
			return;
		}

		$user_profile = $this->user_dao->get_user_by_id($this->get['id']);
		$this->debug("user profile", $user_profile);

		$form = $this->user_edit_form($user_profile);
		$form_value = $form->form_validate();

		if ($form_value != false)
		{
			$this->user_dao->set_user_by_id($this->get['id'], $form_value['username'], $form_value['password'], $form_value['group'], $form_value['first_name'], $form_value['last_name'], $form_value['email']);

			$this->tpl_array['result_set'] = true;
			if ($this->user_dao->error_message == "")
			{
				$form->qform->toggleFrozen(true);
				$this->tpl_array['result_success'] = true;
			} else
			{
				$this->tpl_array['result_success'] = false;
			}
		}

		$this->tpl_array['form'] = $form->get_html();
		$this->parse("user_edit.tpl.php");

	} /* }}} */

	function user_edit_form($default_values) /* {{{ */
	{
		$form = new form("user_edit_form", "post");
		$form->qform->setAttribute("action", "index.php?mod=user&act=edit&id=" . $this->get['id']);

		$form->qform->addDataSource(new HTML_QuickForm2_DataSource_Array(array(
			'username' => $default_values['username'],
			'group' => $default_values['group'],
			'first_name' => $default_values['first_name'],
			'last_name' => $default_values['last_name'],
			'email' => $default_values['email']
		)));

		$form_content = $form->qform->addElement("fieldset")->setLabel("Edit Profile");

		$username = $form_content->addElement("text", "username" /* , array('style' => $default_input_style) */ );
		$username->setLabel("Username :");
		$username->addRule("required", "username is required");
//		$username->toggleFrozen(false);

		$password = $form_content->addElement("text", "password");
		$password->setLabel("Password :");
		$password->addRule("required", "password is required");

		$group_options = array(
			"Administrator",
			"Teacher",
			"Student"
		);

		$group = $form_content->addElement("select", "group", null, array('options' => $group_options));
		$group->setLabel("Group :");
		$group->addRule("required", "group is required");

		$first_name = $form_content->addElement("text", "first_name");
		$first_name->setLabel("First Name :");
		$first_name->addRule("required", "first name is required");

		$last_name = $form_content->addElement("text", "last_name");
		$last_name->setLabel("Last Name :");
		$last_name->addRule("required", "last name is required");
	
		$email = $form_content->addElement("text", "email");
		$email->setLabel("Email :");
		$email->addRule("required", "email is required");

		$form_content->addElement("reset", "testReset", array('value' => "Reset Data"));
		$form_content->addElement("submit", "testSubmit", array('value' => "Update Profile"));

		return $form;

	} /* }}} */

	function user_del() /* {{{ */
	{
		if (! isset($this->get['id']) OR ! is_numeric($this->get['id']))
		{
			$this->error("invalid id");
			return;
		}

		$user_profile = $this->user_dao->get_user_by_id($this->get['id']);
		$this->debug("user profile", $user_profile);

		$form = $this->user_del_form($user_profile);
		$form->qform->toggleFrozen(true);
		$form_value = $form->form_validate();

		if ($form_value != false)
		{
			$this->user_dao->del_user_by_id($this->get['id']);

			$this->tpl_array['result_set'] = true;
			if ($this->user_dao->error_message == "")
			{
				$this->tpl_array['result_success'] = true;
			} else
			{
				$this->tpl_array['result_success'] = false;
			}
		}

		$this->tpl_array['form'] = $form->get_html();
		$this->parse("user_del.tpl.php");

	} /* }}} */

	function user_del_form($default_values) /* {{{ */
	{
		$form = new form("user_del_form", "post");
		$form->qform->setAttribute("action", "index.php?mod=user&act=del&id=" . $this->get['id']);

		$form->qform->addDataSource(new HTML_QuickForm2_DataSource_Array(array(
			'username' => $default_values['username'],
			'group' => $default_values['group'],
			'first_name' => $default_values['first_name'],
			'last_name' => $default_values['last_name'],
			'email' => $default_values['email']
		)));

		$form_content = $form->qform->addElement("fieldset")->setLabel("Delete Profile");

		$username = $form_content->addElement("text", "username" /* , array('style' => $default_input_style) */ );
		$username->setLabel("Username :");
//		$username->addRule("required", "username is required");
//		$username->toggleFrozen(false);

//		$password = $form_content->addElement("text", "password");
//		$password->setLabel("Password :");
//		$password->addRule("required", "password is required");

		$group_options = array(
			"Administrator",
			"Teacher",
			"Student"
		);

		$group = $form_content->addElement("select", "group", null, array('options' => $group_options));
		$group->setLabel("Group :");
//		$group->addRule("required", "group is required");

		$first_name = $form_content->addElement("text", "first_name");
		$first_name->setLabel("First Name :");
//		$first_name->addRule("required", "first name is required");

		$last_name = $form_content->addElement("text", "last_name");
		$last_name->setLabel("Last Name :");
//		$last_name->addRule("required", "last name is required");
	
		$email = $form_content->addElement("text", "email");
		$email->setLabel("Email :");
//		$email->addRule("required", "email is required");

//		$form_content->addElement("reset", "testReset", array('value' => "Reset Data"));
		$form_content->addElement("submit", "testSubmit", array('value' => "Delete Profile"));

		return $form;

	} /* }}} */

}

?>

